package cn.iocoder.yudao.module.pms.service.yanfan.thingsmodeltemplate;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.thingsmodeltemplate.vo.IotYfThingsModelTemplatePageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.thingsmodeltemplate.vo.IotYfThingsModelTemplateSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.yanfan.thingsmodeltemplate.IotYfThingsModelTemplateDO;
import cn.iocoder.yudao.module.pms.dal.mysql.yanfan.thingsmodel.IotYfThingsModelTemplateMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;


import javax.annotation.Resource;

import java.util.Collections;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * yf物模型模板 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class IotThingsModelTemplateServiceImpl implements IotThingsModelTemplateService {

    @Resource
    private IotYfThingsModelTemplateMapper iotYfThingsModelTemplateMapper;

    @Override
    public List<IotYfThingsModelTemplateDO> selectAllByTemplateId(Long templateId) {
        String tempSlaveId = Long.toString(templateId);
        return iotYfThingsModelTemplateMapper.selectAllByTemplateId(templateId, tempSlaveId);
    }

    @Override
    public Long createIotThingsModelTemplate(IotYfThingsModelTemplateSaveReqVO createReqVO) {
        // 插入
        IotYfThingsModelTemplateDO iotThingsModelTemplate = BeanUtils.toBean(createReqVO, IotYfThingsModelTemplateDO.class);
        iotYfThingsModelTemplateMapper.insert(iotThingsModelTemplate);
        // 返回
        return iotThingsModelTemplate.getTemplateId();
    }

    @Override
    public void updateIotThingsModelTemplate(IotYfThingsModelTemplateSaveReqVO updateReqVO) {
        // 校验存在
        validateIotThingsModelTemplateExists(updateReqVO.getTemplateId());
        // 更新
        IotYfThingsModelTemplateDO updateObj = BeanUtils.toBean(updateReqVO, IotYfThingsModelTemplateDO.class);
        iotYfThingsModelTemplateMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotThingsModelTemplate(Long id) {
        // 校验存在
        validateIotThingsModelTemplateExists(id);
        // 删除
        iotYfThingsModelTemplateMapper.deleteById(id);
    }

    private void validateIotThingsModelTemplateExists(Long id) {
        if (iotYfThingsModelTemplateMapper.selectById(id) == null) {
            throw exception(new ErrorCode(222,"不存在物模型模板"));
        }
    }

    @Override
    public IotYfThingsModelTemplateDO getIotThingsModelTemplate(Long id) {
        return iotYfThingsModelTemplateMapper.selectById(id);
    }

    @Override
    public PageResult<IotYfThingsModelTemplateDO> getIotThingsModelTemplatePage(IotYfThingsModelTemplatePageReqVO pageReqVO) {
        return iotYfThingsModelTemplateMapper.selectPage(pageReqVO);
    }

}
